#!/usr/bin/perl

use strict;
use lib qw(.);
use config;

my $ulscr=config::ulscr;
my $unscr=config::unscr;

print "Content-type: text/html; charset=UTF-8\n\n";
print "<html>\n";
print "<head>\n";
print "<meta name=\"viewport\" content=\"width=device-width, initial-scale=0.7\">";
print "<title>file list display</title>\n";
print "</head>\n\n";

my $mobile=1 if($ENV{'HTTP_USER_AGENT'}=~/^Mozilla/);
my ($cgipath, $qrystr) = split(/\?/, $ENV{'REQUEST_URI'});
$cgipath =~ s/\/$//;

my $scrname=$ENV{'SCRIPT_NAME'};
my @scrary=split(/\//, $scrname);
my $scrfile=$scrary[$#scrary];

my $fpath = $ENV{'PATH_TRANSLATED'};
$fpath = $ENV{'DOCUMENT_ROOT'} if($ENV{'PATH_TRANSLATED'} eq "");
$fpath =~ s/\/index\.htm.*$//i;
opendir LIST, "$fpath";
my @tlist = grep !/^\.$/, readdir LIST;
closedir LIST;
$fpath =~ s/\/$//;

my $pathinfo=$ENV{'PATH_INFO'};
$pathinfo=~s/\/$//;

print "<body>\n";
$cgipath=~s/$scrfile/$unscr/;
print "<form action=\"$cgipath\" method=\"post\">\n";
$cgipath=~s/$unscr/$scrfile/;
print "<table>\n";
my ($maxlen, $flen, $splen, $ix);
foreach my $fname (sort(@tlist)){
	$flen=length($fname);
	$maxlen=$flen if($maxlen<$flen);
}
my ($pname, $fstat, $fsize, @fdate);
foreach my $fname (sort(@tlist)){
	$pname =$fname;
	$pname.="?".$qrystr if($qrystr ne "");
	$flen  =length($fname);
	$splen =$maxlen-$flen;
	$fstat =(stat "$fpath/$fname")[9];
	@fdate =split(" ", localtime($fstat));
	$fdate[2]=sprintf("%02d", $fdate[2]);
	$fstat =(stat "$fpath/$fname")[7];
	if( -d "$fpath/$fname" ){
		if($fname=~/^\.\.$/){
			if($cgipath ne $ENV{'SCRIPT_NAME'}){
				print "<tr><td><a href=\"$cgipath/$pname\">Parent Directory</a></td>";
				print "<td></td><td></td><td></td>" if($mobile==1);
				print "<td>rename</td><td>delete</td></tr>\n";
			}
		}
		else{
			$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
			if($fname ne "cgi-bin"){
				print "<tr><td><a href=\"$cgipath/$pname\">".$fname;
				print "&#9;" if($fname=~/\W$/);
				print "</a></td>";
			
				if($mobile==1){
					print "<td>";
					print $fdate[1]."-".$fdate[2]."-".$fdate[4]."</td><td>".$fdate[3]."</td><td>[DIR]</td>";
				}
				print "<td><input type=radio name=oname value=\"$fname\"></td>";
				print "<td><input type=checkbox name=rdname value=\"$fname\"></td></tr>\n";
			}
		}
	}
	else{
		$fsize=$fstat;
		$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
		if($fname!~/^\.ht[a-z]+$/){
			print "<tr><td><a href=\"$pathinfo/$fname\">".$fname;
			print "&#9;" if($fname=~/\W$/);
			print "</a></td>";
			if($mobile==1){
				print "<td>";
				print $fdate[1]."-".$fdate[2]."-".$fdate[4]."</td><td>".$fdate[3]."</td><td>".$fsize;
			}
			print "<td><input type=radio name=oname value=\"$fname\"></td>";
			print "<td><input type=checkbox name=rfname value=\"$fname\"></td></tr>\n";
		}
	}
}
print "</table>\n";
print "<br>\n";
print "rename&nbsp;&nbsp;<input type=text name=nname istyle=3><p>\n";
print "makedir&nbsp;<input type=text name=dname istyle=3><p>\n";
print "<input type=submit value=submit>\n";
print "</form>\n";
my $uagent=$ENV{'HTTP_USER_AGENT'};
$uagent=~s/\(//g;
$uagent=~s/\)$//;
$uagent=~s/\)\s/;\ /g;
$uagent=~s/(\/[0-9]+)\s/$1;\ /g;
my @acol=split(/;\s/, $uagent);
my $browser=shift(@acol);
my $msie=shift(@acol);
my ($iename, $iever, $ufchk);
if($browser eq "Mozilla/4.0 compatible"){
	($iename, $iever)=split(/\s/, $msie);
	$ufchk=1 if($iever>6);
}
else{
	$ufchk=1;
}
if($ufchk==1){
	$cgipath=~s/$scrfile/$ulscr/;
	print "<form action=\"$cgipath\" method=\"post\" enctype=\"multipart/form-data\">\n";
	print "<input type=file name=upfile><p>\n";
	print "<input type=submit value=upload>\n";
	print "</form>\n";
	$cgipath=~s/$ulscr/$scrfile/;
}
print "<br>\n";
if($ENV{'SERVER_SIGNATURE'} ne ""){
	print "<hr>\n";
	print "<br>\n";
	print $ENV{'SERVER_SIGNATURE'};
}
print "</body>\n";
print "</html>\n";

