#!/usr/bin/perl

use strict;
use lib qw(.);
use mconfig;

my $prgroot=mconfig::prgroot;
my $midplay=mconfig::midcmd;
my $midopt=mconfig::midopt;
my $rcpplay=mconfig::rcpcmd;
my $rcpopt=mconfig::rcpopt;
my $mp3play=mconfig::mp3cmd;
my $mp3opt=mconfig::mp3opt;
my $lhacmd=mconfig::lhacmd;
my $zipcmd=mconfig::zipcmd;
my $cmdopt=mconfig::cmdopt;
my $docroot=mconfig::docroot;
my $sfxload=mconfig::sfxload;
my @ext=&mconfig::ext;
my $listmid=&mconfig::midlist;
my $jboxmid=&mconfig::midjbox;

print "Content-type: text/html\; charset=UTF-8\n\n";
$ENV{'PATH_TRANSLATED'}=$ENV{'PWD'} if($ENV{'PATH_TRANSLATED'} eq "");
$ENV{'SCRIPT_NAME'}=~s/$jboxmid/$listmid/;
print "<html>\n";
print "<head>\n";
print "<title>MIDI file Jukebox Play Page</title>\n";
print "</head>\n";
print "<body>\n";
print "<center>\n<h1><a href=\"http://$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}\">Retuen music file list</a></h1>\n</center>\n";
print "<hr>\n";
print "</body>\n";
print "</html>\n";
print "<plaintext>\n";

my $osname=$^O;
my $cygwin="c:/cygwin" if($osname eq "cygwin");
my $fpath=$cygwin.$ENV{'PATH_TRANSLATED'};
opendir LIST, "$fpath";
my @tlist = grep !/^\.$/, readdir LIST;
closedir LIST;
system("$prgroot/sfxload $sfxload") if( -x "$prgroot/sfxload");
my (@col, $cname, $cnt, $cmdall, $ret, $ix);
foreach my $fname (sort(@tlist)){
	if( -f "$fpath/$fname"){
		print "$fpath/$fname\n";
		if($fname=~/\.lzh$/i && ( -x "$prgroot/$lhacmd" || ( -f "$prgroot/$lhacmd" && $osname eq "cygwin"))){
			$cnt=0;
			open LHA, "$prgroot/$lhacmd $cmdopt $fpath/$fname |" or die;
			while(my $line=<LHA>){
				chomp($line);
				@col=split(/\s+/, $line);
				$cname=$col[$#col];
				if($cnt>1){
					$cnt=-2 if($cname=~/\-{3,}/);
					print "$fpath/$fname#$cname\n" if($cname!~/\-{3,}/);
				}
				for($ix=0; $ix<=$#ext; $ix++){
					if($cname=~/\.$ext[$ix]$/i){
						$cmdall="$prgroot/$rcpplay $rcpopt $fpath/$fname#$cname";
						$ret=qx/$cmdall/;
						print "$ret\n";
					}
				}
				$cnt++;
			}
			close LHA;
		}
		elsif($fname=~/\.zip$/i && ( -x "$prgroot/$zipcmd" || ( -f "$prgroot/$zipcmd" && $osname eq "cygwin"))){
			$cnt=0;
			open ZIP, "$prgroot/$zipcmd $cmdopt $fpath/$fname |" or die;
			while(my $line=<ZIP>){
				chomp($line);
				@col=split(/\s+/, $line);
				$cname=$col[$#col];
				if($cnt>2){
					$cnt=-2 if($cname=~/\-{3,}/);
					print "$fpath/$fname#$cname\n" if($cname!~/\-{3,}/);
				}
				for($ix=0; $ix<=$#ext; $ix++){
					if($cname=~/\.$ext[$ix]$/i){
						$cmdall="$prgroot/$rcpplay $rcpopt $fpath/$fname#$cname";
						$ret=qx/$cmdall/;
						print "$ret\n";
					}
				}
				$cnt++;
			}
			close ZIP;
		}
		elsif(($fname=~/\.rcp$/i || $fname=~/\.r36$/i) && ( -x "$prgroot/$rcpplay" || ( -f "$prgroot/$rcpplay" && $osname eq "cygwin"))){
			$cmdall="$prgroot/$rcpplay $rcpopt $fpath/$fname";
			$ret=qx/$cmdall/;
			print "$ret\n";
		}
		elsif($fname=~/\.mid$/i){
			if($midplay=~/timidity/i){
				 if( -x "$prgroot/$midplay" || ( -f "$prgroot/$midplay" && $osname eq "cygwin" )){
					$cmdall="$prgroot/$midplay $midopt $fpath/$fname";
					$ret=qx/$cmdall/;
					print $ret;
				}
			}
			else{
				if( -x "$prgroot/$midplay" ){
					$cmdall="$prgroot/$midplay $fpath/$fname";
					$ret=qx/$cmdall/;
					print $ret;
				}
			}
		}
		elsif($fname=~/\.[a-z0-9]{3}$/i){
			if($^O eq "cygwin"){
				if( -f "$prgroot/$mp3play" && $mp3play!~/mpg123/i ){
					$cmdall="$prgroot/$mp3play";
					$cmdall.=" $mp3opt" if($mp3opt!~/\sfoo:/);
					$cmdall.=" $fpath/$fname";
					$ret=qx/$cmdall/;
					print $ret;
				}
			}
			else{
				if( -x "$prgroot/$mp3play" ){
					$cmdall="$prgroot/$mp3play";
					$cmdall.=" $mp3opt" if($mp3opt!~/\sfoo:/);
					$cmdall.=" $fpath/$fname";
					$ret=qx/$cmdall/;
					print $ret;
				}
			}
		}
		else{
			print "\t$fname play skip.\n";
		}
	}
}
exit 0;

