#!/usr/bin/perl

use strict;
use lib qw(.);
use mconfig;

my $prgroot=mconfig::prgroot;
my $lhacmd=mconfig::lhacmd;
my $zipcmd=mconfig::zipcmd;
my $cmdopt=mconfig::cmdopt;
my @ext=mconfig::ext;
my $midlist=mconfig::midlist;
my $midplay=mconfig::midplay;
my $midjbox=mconfig::midjbox;

print "Content-type: text/html\; charset=UTF-8\n\n";
my ($urlpath, $qrystr) = split(/\?/, $ENV{'REQUEST_URI'});
$urlpath=~s/\/$//;
my @qryary=split('&', $qrystr) if($qrystr ne "");
my ($urlhead, $cgipath, $name, $value, %param);
foreach my $var (@qryary){
        ($name, $value)=split('=', $var);
        $param{$name}=$value;
}
if($param{'server_addr'} ne ""){
	$urlhead="http://";
        $urlhead.=$param{'server_addr'};
	if($param{'http_host'} eq ""){
		$qrystr.="&http_host=";
		$qrystr.=$ENV{'HTTP_HOST'};
	}
}

my $fpath = $ENV{'PATH_TRANSLATED'};
$fpath = $ENV{'DOCUMENT_ROOT'} if($ENV{'PATH_TRANSLATED'} eq "");
$fpath =~ s/\/index\.htm.*$//i;
opendir LIST, "$fpath";
my @tlist = grep !/^\.$/, readdir LIST;
closedir LIST;
$fpath =~ s/\/$//;

my ($fstat, $fsize, $flen, $maxlen, $splen, $fcnt, $ix);
my ($rname, $qname, $ename, $dname, @col);
my $pathinfo=$ENV{'PATH_INFO'};
$pathinfo=~s/\/$//;
print "<html>\n";
print "<head>\n";
print "<title>file list display</title>\n";
print "</head>\n\n";
print "<body>\n";
print "Single Play List<p>\n";
foreach my $fname (sort(@tlist)){
	if( -f "$fpath/$fname"){
		$fstat =(stat "$fpath/$fname")[7];
		$fsize =sprintf("%d", $fstat/1024+0.5);
		$flen  =length($fsize)+1;
		if($fsize==0){
			$fsize =$fstat;
			$flen  =length($fsize);
		}
		$maxlen=$flen if($maxlen<$flen);
	}
}
$maxlen-- if($maxlen==0);
print "<pre>\n" if($maxlen>0);
print "<ul>\n";
foreach my $fname (sort(@tlist)){
	$fcnt  =0;
	$qname =$fname;
	$qname.="?".$qrystr if($qrystr ne "");
	$fstat =(stat "$fpath/$fname")[7];
	if( -d "$fpath/$fname" ){
		$cgipath=$urlpath;
		if($fname =~ /^\.\.$/){
			if($cgipath ne $ENV{'SCRIPT_NAME'}){
				print "<li>";
				for($ix=0; $ix<=$maxlen; $ix++){
					print "&nbsp;";
				}
				print "<a href=\"$cgipath/$qname\">Parent Directory</a>\n";
			}
		}
		else{
			$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
			if($fname ne "cgi-bin"){
				print "<li>";
				for($ix=0; $ix<=$maxlen; $ix++){
					print "&nbsp;";
				}
				print "<a href=\"$cgipath/$qname\">", $fname;
				print "&#9;" if($fname=~/\W$/);
				print "</a>\n";
			}
		}
	}
	else{
		$cgipath=$urlhead.$urlpath;
		$fsize=sprintf("%d", $fstat/1024+0.5);
		$fsize=$fstat if($fsize==0);
		$flen =length($fsize);
		$splen=$maxlen-$flen-2;
		if($fname=~/\.lzh$/i && ( -x "$prgroot/$lhacmd" || ( -f "$prgroot/$lhacmd" && $^O eq "cygwin"))){
			if($fcnt==0){
				print "<li>";
				for($ix=0; $ix<=$splen; $ix++){
					print "&nbsp;";
				}
				print "&nbsp;" if($fstat<512 && $flen<$maxlen);
				print $fsize;
				print "k" if($fstat>=512);
				$cgipath =~ s/$midlist/$midplay/;
				$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
				print "&nbsp;<a href=\"$cgipath/$qname\">$fname</a>";
				print "\n";
				$cgipath =~ s/$midplay/$midlist/;
			}
			open LHA, "$prgroot/$lhacmd $cmdopt $fpath/$fname |" or die;
			while(my $line=<LHA>){
				chomp($line);
				@col=split(/\s+/, $line);
				foreach my $lname (@col){
					$ename=$lname;
				}
				$fcnt=-2 if($fcnt>1 && $ename=~/\-{3,}/); 
				if ($fcnt>1){
					$dname=$ename;
					$dname=~s/(\W)/'%'.unpack('H2', $1)/ge;
					if($qrystr ne ""){
						$rname=$qname."&file=".$dname;
					}
					else{
						$rname=$qname."?file=".$dname;
					}
					$cgipath =~ s/$midlist/$midplay/;
					if($ename=~/\.mid$/i || $ename=~/\.rcp$/i || $ename=~/\.r36$/i){
						print "<li>";
						for($ix=0; $ix<=$maxlen; $ix++){
							print "&nbsp;";
						}
						print "<a href=\"$cgipath/$rname\">$fname#$ename</a>\n";
					}
					$cgipath =~ s/$midplay/$midlist/;
				}
				$fcnt++;
			}
			close LHA;
		}
		elsif($fname=~/\.zip$/i && ( -x "$prgroot/$zipcmd" || ( -f "$prgroot/$zipcmd" && $^O eq "cygwin"))){
			if($fcnt==0){
				print "<li>";
				for($ix=0; $ix<=$splen; $ix++){
					print "&nbsp;";
				}
				print "&nbsp;" if($fstat<512 && $flen<$maxlen);
				print $fsize;
				print "k" if($fstat>=512);
				$cgipath =~ s/$midlist/$midplay/;
				$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
				print "&nbsp;<a href=\"$cgipath/$qname\">$fname</a>";
				print "\n";
				$cgipath =~ s/$midplay/$midlist/;
			}
			open ZIP, "$prgroot/$zipcmd $cmdopt $fpath/$fname |" or die;
			while(my $line=<ZIP>){
				chomp($line);
				@col=split(/\s+/, $line);
				foreach my $zname (@col){
					$ename=$zname;
				}
				$fcnt=-2 if($fcnt>2 && $ename=~/\-{3,}/); 
				if($fcnt>2){
					$dname=$ename;
					$dname=~s/(\W)/'%'.unpack('H2', $1)/ge;
					if($qrystr ne ""){
						$rname=$qname."&file=".$dname;
					}
					else{
						$rname=$qname."?file=".$dname;
					}
					$cgipath =~ s/$midlist/$midplay/;
					if($ename=~/\.mid$/i || $ename=~/\.rcp$/i || $ename=~/\.r36$/i){
						print "<li>";
						for($ix=0; $ix<=$maxlen; $ix++){
							print "&nbsp;";
						}
						print "<a href=\"$cgipath/$rname\">$fname#$ename</a>\n";
					}
					$cgipath =~ s/$midplay/$midlist/;
				}
				$fcnt++;
			}
			close ZIP;
		}
		else{
			for($ix=0; $ix<=$#ext; $ix++){
				$cgipath =~ s/$midlist/$midplay/ if($fname=~/\.$ext[$ix]$/i);
			}
			$fname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
			if($fname !~ /^\..+$/){
				print "<li>";
				for($ix=0; $ix<=$splen; $ix++){
					print "&nbsp;";
				}
				print "&nbsp;" if($fstat<512 && $flen<$maxlen);
				print $fsize;
				print "k" if($fstat>=512);
				print "&nbsp;";
				if($cgipath=~/$midplay/){
					print "<a href=\"$cgipath/$qname\">";
				}
				else{
					print "<a href=\"$pathinfo/$fname\">";
				}
				print $fname;
				print "&#9;" if($fname=~/\W$/);
				print "</a>\n";
			}
			$cgipath =~ s/$midplay/$midlist/;
		}
	}
}
print "</ul>\n";
print "</pre>\n" if($maxlen>0);
if($param{'server_addr'} eq ""){
print "Jukebox Play List<p>\n";
print "<ul>\n";
foreach my $jname (sort(@tlist)){
	$qname = $jname;
	$qname.= "?".$qrystr if($qrystr ne "");
	if( -d "$fpath/$jname" && $jname!~/^\.\.$/){
		$cgipath =~ s/$midlist/$midjbox/;
		$jname =~ s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
		print "<li><a href=\"$cgipath/$qname\">$jname</a>\n" if($jname ne "cgi-bin");
		$cgipath =~ s/$midjbox/$midlist/;
	}
}
print "</ul>\n";
}
if($ENV{'SERVER_SIGNATURE'} ne ""){
	print "<hr>\n";
	print "<br>\n";
	print $ENV{'SERVER_SIGNATURE'};
}
print "</body>\n";
print "</html>\n";

