#!/usr/bin/perl

use strict;
use lib qw(.);
use mconfig;

my $prgroot=mconfig::prgroot;
my $midplay=mconfig::midcmd;
$midplay.=" ";
$midplay.=mconfig::midopt;
my $rcpplay=mconfig::rcpcmd;
$rcpplay.=" ";
$rcpplay.=mconfig::rcpopt;
$midplay=$rcpplay if($midplay=~/timidity/i);
my $mp3play=mconfig::mp3cmd;
my $mp3opt=mconfig::mp3opt;
my $docroot=mconfig::docroot;
my $sfxload=mconfig::sfxload;
my $listmid=mconfig::midlist;
my $playmid=mconfig::midplay;

print "Content-type: text/html; charset=UTF-8\n\n";

my ($urlhead, $name, $value, %param);
my $osname=$^O;
$ENV{'CYGWIN'}="error_start=dumper" if($osname eq "cygwin");
my $cygwin  = "c:/cygwin" if(defined $ENV{'CYGWIN'});
my ($urlpath, $qrystr) = split(/\?/, $ENV{'REQUEST_URI'});
my @qryary=split('&', $qrystr);
foreach my $var (@qryary){
	($name, $value)=split('=', $var);
	$param{$name}=$value;
}
if($param{'http_host'} ne ""){
	$urlhead="http://";
	$urlhead.=$param{'http_host'};
	$qrystr=~s/http_host=$param{'http_host'}//;
}
my $cgipath=$urlhead.$urlpath;
$qrystr=~s/file=$param{'file'}//;
$qrystr=~s/&{2,}/&/g;
$qrystr=~s/^&//;
$qrystr=~s/&$//;

my @finput=split(/\//, $cgipath);
my $tname=$finput[$#finput];
my @ttype=split(/\./, $tname);
my $ftype=$ttype[$#ttype];
$cgipath=~ s/$playmid/$listmid/;
$cgipath=~ s/\/$tname//;
$cgipath.= "?".$qrystr if($qrystr ne "");
$param{'file'}=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
if($param{'file'} ne ""){
	@finput=split(/\//, $param{'file'});
	$tname=$finput[$#finput];
}
my $orgname=$tname;
$tname=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>$tname Player Page</TITLE>\n";
print "</HEAD>\n";
print "<BODY BGCOLOR=#FFFFFF TEXT=#000000>\n";
print "<CENTER>\n";
print "<H1><A HREF=\"$cgipath\">Return music file list</A></H1>\n";
print "<HR>\n";
print "</CENTER>\n";
print "</BODY>\n";
print "</HTML>\n";
print "<PLAINTEXT>\n";

print "OS: $osname\n";
my $uagent=$ENV{'HTTP_USER_AGENT'};
$uagent=~s/\(//g;
$uagent=~s/\)$//;
$uagent=~s/\)\s/;\ /g;
$uagent=~s/(\/[0-9]+)\s/$1;\ /g;
my @acol = split(/;\s/, $uagent);
my $browser = shift(@acol);
print "browser: $browser\n";
my ($fullname, $platform, $icnt);
for($icnt=0; $icnt<=$#acol; $icnt++){
	$platform.=sprintf("%s; ", $acol[$icnt]) if($icnt<$#acol);
	$platform.=sprintf("%s", $acol[$icnt]) if($icnt==$#acol);
}
print "platform: $platform\n";
my $filename=$ENV{'PATH_TRANSLATED'};
$filename=$urlhead.$ENV{'PATH_INFO'} if($param{'http_host'} ne "");
$filename=~s/$tname/$orgname/ if($tname=~/\W/ && $orgname=~/%[A-Fa-f0-9]{2}/);
if($param{'file'} ne ""){
	$param{'file'}=~s/(\W)/\\$1/g;
	$filename .= "#".$param{'file'};
}
$param{'opt'}=~s/%([A-Fa-f0-9]{2})/pack('H2', $1)/ge;
$fullname=$cygwin if(defined $cygwin);
$fullname.=$filename;
print "program: $param{'play'}\n" if($param{'play'} ne "");
print "option: $param{'opt'}\n" if($param{'opt'} ne "");
print "filetype: ", uc($ftype), "\n";
system("$prgroot/sfxload $sfxload") if( -x "$prgroot/sfxload");
my ($cmdall, $ret, $msie, $iename, $iever);
if($browser eq "Mozilla/4.0 compatible"){
	$msie=shift(@acol);
	($iename, $iever)=split(/\s/, $msie);
	if($iever<7){
		print "Web browser above $iename 7.0 is needed!!\n";
		print "$tname is playing stop.\n";
		exit 1;
	}
}
if($param{'play'} ne ""){
	if($param{'play'}=~/timidity/i){
		$param{'opt'}="-Od -id" if($param{'opt'} eq "");
	}
	else{
		if($browser eq "Mozilla/4.0 compatible"){
			print "Web browser above Mozilla/5.0 is needed!!\n";
			print "$tname is playing stop.\n";
			exit 1;
		}
	}
	print "filename: $filename\n" if($param{'play'}!~/timidity/i);
	$cmdall=$prgroot."/".$param{'play'}." ".$param{'opt'}." ".$fullname." &";
	$ret=qx/$cmdall/;
	print $ret;
}
elsif($ftype=~/mid/i){
	$cmdall=$prgroot."/".$midplay." ".$fullname." &";
	$ret=qx/$cmdall/;
	print $ret;
}
elsif($ftype=~/rcp/i || $ftype=~/r36/i || $ftype=~/lzh/i || $ftype=~/zip/i){
	$cmdall=$prgroot."/".$rcpplay." ".$fullname." &";
	$ret=qx/$cmdall/;
	print $ret;
}
elsif( -x "$prgroot/$mp3play" && $osname ne "cygwin"){
	print "filename: $filename\n";
	if($mp3opt!~/\sfoo:/){
		$mp3play.=" ";
		$mp3play.=$mp3opt;
	}
	$cmdall=$prgroot."/".$mp3play." ".$filename." &";
	$ret=qx/$cmdall/;
	print $ret;
}
elsif( -f "$prgroot/$mp3play" && $osname eq "cygwin" && $mp3play!~/mpg123/i){
	if($mp3opt!~/\sfoo:/){
		$mp3play.=" ";
		$mp3play.=$mp3opt;
	}
	$cmdall=$prgroot."/".$mp3play." ".$fullname." &";
	$ret=qx/$cmdall/;
	print $ret;
}
else{
	print "Not installed $prgroot/$mp3play\n";
	print "$tname is playing stop.\n";
}
exit 0;

