#!/usr/bin/perl

use strict;
use lib qw(.);
use mconfig;

my $prgroot=mconfig::prgroot;
my $rcpcmd=mconfig::rcpcmd;
my $httpcmd=mconfig::httpcmd;
my $httpopt=mconfig::httpopt;
my $mp3list=mconfig::mp3list;
my $mp3play=mconfig::mp3play;
my $mp3jbls=mconfig::mp3jbls;
my $mp3jbox=mconfig::mp3jbox;
my @ext=mconfig::ext;

print "Content-type: text/html; charset=UTF-8\n\n";
print "<html>\n";
print "<head>\n";
print "<title>URL file list display</title>\n";
print "</head>\n";
print "<body>\n";

if($ENV{'REQUEST_URI'} eq ""){
	print "<CENTER>\n";
	print "REQUEST_URI environment variable is required.<p>\n";
	print "</CENTER>\n";
	print "</body>\n";
	print "</html>\n";
	exit 1;
}

my ($spltstr, $name, $value, %param);
my ($cgipath, $qrystr) = split(/\?/, $ENV{'REQUEST_URI'});
$ENV{'QUERY_STRING'}=$qrystr if($ENV{'QUERY_STRING'} eq "");
my @qryval=split('&', $ENV{'QUERY_STRING'});
foreach my $qdmy (@qryval){
	($name, $value)=split('=', $qdmy);
	$param{$name}=$value;
}
my @sname=split(/\//, $0);
foreach my $sdmy (@sname){
	$spltstr=$sdmy;
}
my ($cgihead, $pathinfo)=split($spltstr, $cgipath);
$ENV{'SCRIPT_NAME'}=$cgihead.$spltstr if($ENV{'SCRIPT_NAME'} eq "");
$ENV{'PATH_INFO'}=$pathinfo if($ENV{'PATH_INFO'} eq "");

if((!-x "$prgroot/$httpcmd" && $^O ne "cygwin") || (!-f "$prgroot/$httpcmd" && $^O eq "cygwin")){
	$cgipath=~s/$mp3jbls/$mp3list/;
	print "<center>\n";
	print "<a href=\"http://";
	print $param{'server_addr'}, $cgipath;
	print "\"><h2>Not installed $prgroot/$httpcmd</h2></a>\n";
	print "</center>\n";
	print "<hr>\n<p>\n";
	print $ENV{'SERVER_SIGNATURE'};
	print "</body>\n</html>\n";
	exit 1;
}
my $urlhead = "http://".$param{'server_addr'}.$ENV{'PATH_INFO'};
my $cmdall="$prgroot/$httpcmd $httpopt $urlhead";
my $ret=qx/$cmdall/;
my @url=split(/\n/, $ret);
my ($ref, $fname, $scrname, $fprt, @filep, @col, @spurl);
my $cnt=0;
foreach my $fdmy (@url){
	chomp($fdmy);
	$fdmy=~s/\[\s{3}\]/\[BIN\]/;
	@col=split(/\s+/, $fdmy);
	$col[2]=~s/\[[0-9]+\]//g;
	if($ref eq "References" && $cnt>0){
		$cnt-- if($col[2]=~/\/?[A-Z]=[A-Z]$/);
		if($col[2]=~/\/$/){
			$col[2]=~s/\/$//;
			@spurl=split(/\//, $col[2]);
			$col[2]=~s/$spurl[2]/$param{'server_addr'}/ if($param{'server_addr'} ne "");
			foreach my $idmy (@spurl){
				$fname=$idmy;
			}
			print "<li><a href=\"http://$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}..?$ENV{'QUERY_STRING'}\">$col[2]</a><br>\n" if($cnt==2);
			print "<li><a href=\"http://$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}$fname/?$ENV{'QUERY_STRING'}\">$col[2]</a><br>\n" if($cnt>2);
		}
		else{
			$fprt=0;
			@filep=split(/\//, $col[2]);
			$col[2]=~s/$filep[2]/$param{'server_addr'}/ if($param{'server_addr'} ne "");
			foreach my $dmy (@ext){
				if($col[2]=~/\.$dmy$/i){
					$scrname=$ENV{'SCRIPT_NAME'};
					$scrname=~s/$mp3jbls/$mp3play/;
					if($cnt>2){
						print "<li><a href=\"http://$ENV{'HTTP_HOST'}$scrname$ENV{'PATH_INFO'}/$filep[$#filep]?$ENV{'QUERY_STRING'}&http_host=$ENV{'HTTP_HOST'}&ret=$mp3jbls&del=no";
						print "&play=".$rcpcmd if($dmy=~/mid/i);
						print "\">$col[2]</a><br>\n";
					}
					$fprt=1;
				}
			}
			print "<li><a href=\"$col[2]\">$col[2]</a><br>\n" if($cnt>2 && $fprt==0);
		}
		$cnt++
	}
	if($col[0] eq "References" && $cnt==0){
		print "$fdmy<br>\n";
		print "<ol>\n";
		$ref=$col[0];
		$cnt++;
	}
}
print "</ol>\n" if($cnt>0);
$ENV{'SCRIPT_NAME'}=~s/$mp3jbls/$mp3jbox/;
if($param{'http_host'} eq ""){
	$ENV{'QUERY_STRING'}.="&http_host=";
	$ENV{'QUERY_STRING'}.=$ENV{'HTTP_HOST'};
}
$cnt=0 if($cnt>0);
foreach my $jdmy (@url){
	chomp($jdmy);
	$jdmy=~s/\[\s{3}\]/\[BIN\]/;
	@col=split(/\s+/, $jdmy);
	$col[2]=~s/\[[0-9]+\]//g;
	if($ref eq "References" && $cnt>0){
		$cnt-- if($col[2]=~/\/\?.+$/);
		if($col[2]=~/\/$/){
			$col[2]=~s/\/$//;
			@spurl=split(/\//, $col[2]);
			$col[2]=~s/$spurl[2]/$param{'server_addr'}/ if($param{'server_addr'} ne "");
			foreach my $idmy (@spurl){
				$fname=$idmy;
			}
			print "<li><a href=\"http://$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}$fname/?$ENV{'QUERY_STRING'}\">$col[2]</a><br>\n" if($cnt>2);
		}
		$cnt++;
	}
	if($col[0] eq "References" && $cnt==0){
		print "Jukebox List<br>\n";
		print "<ol>\n";
		$ref=$col[0];
		$cnt++;
	}
}
print "</ol>\n" if($cnt>0);
print "</body>\n";
print "</html>\n";
if($cnt<=0){
	print "<plaintext>\n";
	print "$ret\n";
}
exit 0;

